'DotNetNuke -  http://www.dotnetnuke.com
' GoogleSearch Module - http://www.boul.nl
' Copyright (c) 2002-2003
' by Roeland Kuipers - http://www.boul.nl
'
' Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated 
' documentation files (the "Software"), to deal in the Software without restriction, including without limitation 
' the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and 
' to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'
' The above copyright notice and this permission notice shall be included in all copies or substantial portions 
' of the Software.
'
' THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED 
' TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL 
' THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF 
' CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
' DEALINGS IN THE SOFTWARE.
'
' Roeland Kuipers (http://www.boul.nl) 12-06-2003 - First Public Release 1.0.1
' 
Namespace dotnetnuke
    Public MustInherit Class GoogleSearch

        Inherits PortalModuleControl

        Protected WithEvents dlResults As System.Web.UI.WebControls.DataList
        Dim GKey As String
        Dim MaxResults As Integer
        Dim Keyword As String
        Dim Index As Integer
        Dim search As Google.GoogleSearchService = New Google.GoogleSearchService()
        Dim result As Google.GoogleSearchResult
        Dim TotResults As Integer
        Dim startIdx As Integer
        Dim endIdx As Integer
        Dim FilterAdult As Boolean
        Dim FilterSimilar As Boolean
        Protected WithEvents lblSearchTerm As System.Web.UI.WebControls.Label
        Protected WithEvents lblSearchInfo As System.Web.UI.WebControls.Label
        Protected WithEvents lblSearchedFor As System.Web.UI.WebControls.Label
        Protected WithEvents cmdNext As System.Web.UI.WebControls.LinkButton
        Protected WithEvents cmdBack As System.Web.UI.WebControls.LinkButton
        Protected WithEvents txtKeyword As System.Web.UI.WebControls.TextBox
        Protected WithEvents cmdSearch As System.Web.UI.WebControls.LinkButton
        Protected WithEvents lnkSuggestion As System.Web.UI.WebControls.LinkButton
        Protected WithEvents lblerror As System.Web.UI.WebControls.Label
        Protected WithEvents Header As System.Web.UI.WebControls.Table
        Protected WithEvents footer As System.Web.UI.WebControls.Table
        Protected WithEvents pnlModuleContent As System.Web.UI.WebControls.Panel
        Dim suggestion As String

#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            'Put user code to initialize the page here


            'Get Modulesettings
            GKey = CType(Settings("GKey"), String)
            MaxResults = CType(Settings("GMaxResults"), Integer)
            FilterAdult = CType(Settings("GFilterAdult"), Boolean)
            FilterSimilar = CType(Settings("GFilterSimilar"), Boolean)
            Keyword = txtKeyword.Text

            Index = 0



        End Sub





        Public Sub doSearch(ByVal GKey As String, ByVal Keyword As String, ByVal MaxResults As String, ByVal index As Integer)

            'Do the actual search!
            result = search.doGoogleSearch(GKey, Keyword, index, MaxResults, FilterSimilar, "", FilterAdult, "", "", "")

            'Check if there's a spelling suggestion for the given keyword
            suggestion = search.doSpellingSuggestion(GKey, Keyword)

            'Put the results into a datalist
            dlResults.DataSource = result.resultElements
            dlResults.DataBind()

            'Set the index variables needed to browse through the results etc
            TotResults = result.estimatedTotalResultsCount
            startIdx = result.startIndex
            endIdx = result.endIndex
            Session("DL_totResults") = TotResults
            Session("DL_endIdx") = endIdx
            Session("DL_startIdx") = startIdx
            Session("Suggestion") = suggestion

            'Check if there's a spelling suggestion if so display the suggestion
            If Not suggestion = "" Then
                lnkSuggestion.Text = "Did you mean " & Chr(34) & suggestion & Chr(34) & "?"
                lnkSuggestion.Visible = True
            Else
                lnkSuggestion.Visible = False
            End If

            'Check if there are any results otherwise show searchtip and dispose the datalist
            If dlResults.Items.Count = 0 Then
                lblSearchInfo.Text = result.searchTips
                dlResults.Dispose()
                Header.Visible = False
                footer.Visible = False

            Else

                Header.Visible = True
                footer.Visible = True

                'Show search specs (searchtime totalresults etc)
                lblSearchInfo.Text = "Viewing records " & String.Format("{0:#,###}", startIdx) & _
                " - " & String.Format("{0:#,###}", startIdx + MaxResults - 1) & " of about " & _
                String.Format("{0:#,###}", result.estimatedTotalResultsCount) & ".  Search took " & _
                String.Format("{0:0.000}", result.searchTime) & " sec."
                lblSearchedFor.Visible = True
                lblSearchTerm.Text = result.searchQuery

            End If

            'Check if the next and previous command have to be enabled
            If startIdx > MaxResults Then
                cmdBack.Enabled = True
            Else
                cmdBack.Enabled = False
            End If
            If Not dlResults.Items.Count < MaxResults Then
                cmdNext.Enabled = True
            Else
                cmdNext.Enabled = False
            End If

        End Sub

        Private Sub cmdSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSearch.Click

            'Search button clicked so dosearch() and show the next/prev commands!

            Try
                If Not GKey = "" Then 'Gkey defined?
                    doSearch(GKey, Keyword, MaxResults, Index)
                    cmdNext.Visible = True
                    cmdBack.Visible = True
                End If
            Catch ex As System.Web.Services.Protocols.SoapException
                lblerror.Text = ex.Message.ToString() 'Catch soap exceptions!
            End Try
        End Sub

        Private Sub lnkSuggestion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lnkSuggestion.Click

            'The user wants to use the given suggestion so do a new search
            suggestion = Session("Suggestion")
            txtKeyword.Text = suggestion

            Try
                doSearch(GKey, suggestion, MaxResults, Index)
            Catch ex As System.Web.Services.Protocols.SoapException
                lblerror.Text = ex.Message.ToString() 'Catch soap exceptions!
            End Try

        End Sub
        Private Sub cmdBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdBack.Click
            'Go back in the results

            startIdx = CInt(Session("DL_startIdx"))

            If startIdx > 0 And startIdx > MaxResults Then

                Index = startIdx - MaxResults - 1

                Try
                    doSearch(GKey, Keyword, MaxResults, Index)
                Catch ex As System.Web.Services.Protocols.SoapException
                    lblerror.Text = ex.Message.ToString() 'Catch soap exceptions!
                End Try

            Else
                cmdBack.Enabled = False
            End If
        End Sub

        Private Sub cmdNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdNext.Click

            'go forward in the results

            TotResults = CInt(Session("DL_totResults"))
            endIdx = CInt(Session("DL_endIdx"))

            If Not dlResults.Items.Count < MaxResults Then

                Try
                    doSearch(GKey, Keyword, MaxResults, endIdx)
                Catch ex As System.Web.Services.Protocols.SoapException
                    lblerror.Text = ex.Message.ToString() 'Catch soap exceptions!
                End Try

            Else
                cmdNext.Enabled = False
            End If
        End Sub
    End Class
End Namespace